"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactRedux = require("react-redux");

var _reduxSagaRequests = require("redux-saga-requests");

var _propTypesValidators = require("./propTypesValidators");

var Query = function Query(_ref) {
  var type = _ref.type,
      requestKey = _ref.requestKey,
      selector = _ref.selector,
      defaultData = _ref.defaultData,
      multiple = _ref.multiple,
      children = _ref.children,
      Component = _ref.component,
      isDataEmpty = _ref.isDataEmpty,
      showLoaderDuringRefetch = _ref.showLoaderDuringRefetch,
      noDataMessage = _ref.noDataMessage,
      ErrorComponent = _ref.errorComponent,
      errorComponentProps = _ref.errorComponentProps,
      LoadingComponent = _ref.loadingComponent,
      loadingComponentProps = _ref.loadingComponentProps,
      extraProps = (0, _objectWithoutPropertiesLoose2["default"])(_ref, ["type", "requestKey", "selector", "defaultData", "multiple", "children", "component", "isDataEmpty", "showLoaderDuringRefetch", "noDataMessage", "errorComponent", "errorComponentProps", "loadingComponent", "loadingComponentProps"]);
  var query = (0, _reactRedux.useSelector)(selector || (0, _reduxSagaRequests.getQuerySelector)({
    type: type,
    requestKey: requestKey,
    defaultData: defaultData,
    multiple: multiple
  }));
  var dataEmpty = isDataEmpty(query);

  if (query.loading && (showLoaderDuringRefetch || dataEmpty)) {
    return LoadingComponent ? _react["default"].createElement(LoadingComponent, loadingComponentProps) : null;
  }

  if (query.error) {
    return ErrorComponent ? _react["default"].createElement(ErrorComponent, (0, _extends2["default"])({
      error: query.error
    }, errorComponentProps)) : null;
  }

  if (dataEmpty) {
    return noDataMessage;
  }

  if (children) {
    return children(query);
  }

  return _react["default"].createElement(Component, (0, _extends2["default"])({
    query: query
  }, extraProps));
};

Query.defaultProps = {
  isDataEmpty: function isDataEmpty(query) {
    return Array.isArray(query.data) ? query.data.length === 0 : !query.data;
  },
  showLoaderDuringRefetch: true,
  noDataMessage: null,
  multiple: false
};
Query.propTypes = process.env.NODE_ENV !== "production" ? {
  type: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].func]),
  requestKey: _propTypes["default"].string,
  selector: _propTypes["default"].func,
  multiple: _propTypes["default"].bool,
  defaultData: _propTypes["default"].any,
  children: _propTypes["default"].func,
  component: (0, _propTypesValidators.reactComponentPropType)('Query'),
  isDataEmpty: _propTypes["default"].func,
  showLoaderDuringRefetch: _propTypes["default"].bool,
  noDataMessage: _propTypes["default"].node,
  errorComponent: (0, _propTypesValidators.reactComponentPropType)('Query'),
  errorComponentProps: _propTypes["default"].objectOf(_propTypes["default"].any),
  loadingComponent: (0, _propTypesValidators.reactComponentPropType)('Query'),
  loadingComponentProps: _propTypes["default"].objectOf(_propTypes["default"].any)
} : {};
var _default = Query;
exports["default"] = _default;